# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class Analysis(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'data_query': 'str',
        'id': 'int',
        'name': 'str'
    }

    attribute_map = {
        'data_query': 'data_query',
        'id': 'id',
        'name': 'name'
    }

    def __init__(self, data_query='*', id=None, name=None, local_vars_configuration=None):  # noqa: E501
        """Analysis - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._data_query = None
        self._id = None
        self._name = None
        self.discriminator = None

        if data_query is not None:
            self.data_query = data_query
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name

    @property
    def data_query(self):
        """
        Lucene query string used to retrieve entities to analyze.

        :return: The data_query of this Analysis. 
        :rtype: str
        """
        return self._data_query

    @data_query.setter
    def data_query(self, data_query):
        """
        Lucene query string used to retrieve entities to analyze.

        :param data_query: The data_query of this Analysis.
        :type: str
        """

        self._data_query = data_query

    @property
    def id(self):
        """
        Unique integer identifying the analysis.

        :return: The id of this Analysis. 
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Unique integer identifying the analysis.

        :param id: The id of this Analysis.
        :type: int
        """

        self._id = id

    @property
    def name(self):
        """
        Name of analysis.

        :return: The name of this Analysis. 
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Name of analysis.

        :param name: The name of this Analysis.
        :type: str
        """

        self._name = name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Analysis):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Analysis):
            return True

        return self.to_dict() != other.to_dict()
