# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class AutocompleteService(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'match_any': 'bool',
        'service_url': 'str'
    }

    attribute_map = {
        'match_any': 'match_any',
        'service_url': 'serviceUrl'
    }

    def __init__(self, match_any=False, service_url=None, local_vars_configuration=None):  # noqa: E501
        """AutocompleteService - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._match_any = None
        self._service_url = None
        self.discriminator = None

        if match_any is not None:
            self.match_any = match_any
        if service_url is not None:
            self.service_url = service_url

    @property
    def match_any(self):
        """
        If true, autocomplete will find leaves with any part of name matching the query. Otherwise only leaf names that start with the query are returned.

        :return: The match_any of this AutocompleteService. 
        :rtype: bool
        """
        return self._match_any

    @match_any.setter
    def match_any(self, match_any):
        """
        If true, autocomplete will find leaves with any part of name matching the query. Otherwise only leaf names that start with the query are returned.

        :param match_any: The match_any of this AutocompleteService.
        :type: bool
        """

        self._match_any = match_any

    @property
    def service_url(self):
        """
        URL of the autocomplete service.

        :return: The service_url of this AutocompleteService. 
        :rtype: str
        """
        return self._service_url

    @service_url.setter
    def service_url(self, service_url):
        """
        URL of the autocomplete service.

        :param service_url: The service_url of this AutocompleteService.
        :type: str
        """

        self._service_url = service_url

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AutocompleteService):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AutocompleteService):
            return True

        return self.to_dict() != other.to_dict()
